<?php

class weixin_api{

    public function __construct($app){
        $this->wechat = kernel::single('weixin_wechat');
        $this->weixinObject = kernel::single('weixin_object');
    }

    public function api(){
        //签名验证，消息有效性验证
        if( !empty($_GET) && $this->doGet() ){
            echo $_GET["echostr"];
        }

        $postStr = $GLOBALS["HTTP_RAW_POST_DATA"];
        if( !empty($postStr) ){
            $this->dopost($postStr);
        }else{
            echo "";
        }
    }

    /**
     * 处理微信消息有效验证
     */
    public function doget(){
        //获取到token
        $token = $this->weixinObject->get_token($_GET['eid']);
        //验证
        if( $this->wechat->checkSignature($_GET["signature"], $_GET["timestamp"], $_GET["nonce"], $token) ){
            return true;
        }else{
            return false;
        }
    }

    public function dopost($postXml){
        $postArray = kernel::single('site_utility_xml')->xml2array($postXml);
        $postData  = $postArray['xml'];

        //公众账号ID获取
        $weixin_id = $postData['ToUserName'];
        $bind = app::get('weixin')->model('bind')->getList('id,eid',array('weixin_id'=>$weixin_id,'status'=>'active'));
        if( !empty($bind) ){
            $postData['bind_id'] = $bind[0]['id'];
            $postData['eid'] = $bind[0]['eid'];
        }else{
            $this->weixinObject->send('');
        }

        switch($postData['MsgType']){
        case 'event':
            /**
             * subscribe(订阅)、unsubscribe(取消订阅)
             * scan 带参数二维码事件
             * location 上报地理位置事件
             * click 自定义菜单事件
             * view  点击菜单跳转链接时的事件推送
             * */
            $method = strtolower($postData['Event']);
            if( method_exists($this->wechat,$method) ){
                $this->wechat->$method($postData);
            }else{
                $this->weixinObject->send('');
            }
            break;
        default:
            $this->wechat->commonMsg($postData);
        }
    }
}
